;***************************************************************
; This Subroutine outputs the Date/Time in the following Format:
; Day of Week,Day of Month.Month.Year,Hours:Minutes:Seconds
;
; This code is straight forward to allow you to change the
; Output-Format to your needs.No attempt is made therefore
; to optimize the code.
;***************************************************************
Show_Date:
;	rjmp Show_Time_only		;show HH:MM:SS only
Show_Day_of_Week:
	clr Work1				;need a "zero" to add with carry
	ldi	ZL,low(day_ones)
	ldi	ZH,high(day_ones)
	ld	Work,Z
	cpi Work,0x31			;ASCII "1" = Sunday
	breq Sonn_
	cpi Work,0x32			;ASCII "2" = Monday
	breq Mon_
	cpi Work,0x33
	breq Dien_
	cpi Work,0x34
	breq Mitt_
	cpi Work,0x35
	breq Donn_
	cpi Work,0x36
	breq Frei_
	cpi Work,0x37
	breq Sams_
Sonn_:
	ldi Work,0
	rjmp Show_Full
Mon_:
	ldi	Work,2
	rjmp Show_Full
Dien_:
	ldi Work,4
	rjmp Show_Full
Mitt_:
	ldi Work,6
	rjmp Show_Full
Donn_:
	ldi Work,8
	rjmp Show_Full
Frei_:
	ldi Work,10
	rjmp Show_Full
Sams_:
	ldi Work,12
Show_Full:						;sends Weekday,DD.MM.YYYY,HH:MM:SS
    ldi     ZL, low(Sun*2)		;Z points to "day=1"
    ldi     ZH, high(Sun*2)
	add		ZL,Work				;add "Day-of-Week" to Pointer
	adc		ZH,Work1
    lpm     Txbyte, Z+			;send Day-of-Week
	rcall	putchar				
    lpm     Txbyte, Z+			
	rcall	putchar				
	ldi 	Txbyte,','
	rcall	putchar
	lds  	Txbyte,date_tens
	rcall 	putchar
	lds 	Txbyte,date_ones
	rcall 	putchar
	ldi 	Txbyte,'.'
	rcall	putchar
	lds 	Txbyte,month_tens
	rcall 	putchar
	lds 	Txbyte,month_ones
	rcall 	putchar
	ldi 	Txbyte,'.'
	rcall	putchar
	lds 	Txbyte,year_thous
	rcall 	putchar
	lds 	Txbyte,year_hundr
	rcall 	putchar
	lds 	Txbyte,year_tens
	rcall 	putchar
	lds 	Txbyte,year_ones
	rcall 	putchar
	ldi 	Txbyte,','
	rcall	putchar
;----------------------------------------------------
Show_Time_only:					;shows HH:MM:SS only
;----------------------------------------------------
	lds Txbyte,hour_tens
	rcall putchar
	lds Txbyte,hour_ones
	rcall putchar
	ldi Txbyte,':'
	rcall putchar
	lds Txbyte,min_tens
	rcall putchar
	lds Txbyte,min_ones
	rcall putchar
;----------------------------
;if you dont like seconds
No_seconds:						;shows HH:MM only						
;	rjmp End_Show
;----------------------------
	ldi Txbyte,':'
	rcall putchar
;----------------------------
Show_Seconds_only:
;----------------------------
	lds Txbyte,sec_tens			;shows SS only
	rcall putchar
	lds Txbyte,sec_ones
	rcall putchar
End_Show:
	ldi Txbyte,0x0d				;send new line
	rcall putchar
	ldi Txbyte,0x0a
	rcall putchar
	ret

;********** A P P L I C A T I O N   N O T E   A V R 3 0 5 ******************
;*				
;*					Software RS232 UART
;*
;***************************************************************************

getchar:				;RxD holds received character
;	in		bitcnt,SREG
;	push	bitcnt
	ldi 	bitcnt,9	;8 data bit + 1 stop bit
getchar1:
	sbic 	RS232_In,RxD;Wait for start bit
	rjmp 	getchar1
	rcall UART_delay	;0.5 bit delay
getchar2:
	rcall UART_delay	;1 bit delay
	rcall UART_delay		
	clc					;clear carry
	sbic 	RS232_In,RxD;if RX pin high
	sec					;set carry
	dec 	bitcnt		;If bit is stop bit
	breq 	getchar3	;return
						;else
	ror 	Rxbyte		;shift bit into Rxbyte
	rjmp 	getchar2	;go get next
getchar3:
;	pop		bitcnt
;	out		SREG,bitcnt
	ret
;---------------------------------------------------------
;.equ		sb	=1		;Number of stop bits (1,2)

putchar:				;TxD is transmitted to RS232 
;	in		bitcnt,SREG
;	push	bitcnt
	ldi	bitcnt,9+sb		;1+8+sb (sb is # of stop bits)
	com	Txbyte			;Inverte everything
	sec					;Start bit
putchar0:
	brcc putchar1		;If carry set
	cbi	RS232_Port,TxD	;send a '0'
	rjmp	putchar2	;else	
putchar1:
	sbi	RS232_Port,TxD	;send a '1'
	nop
putchar2:
	rcall UART_delay	;One bit delay
	rcall UART_delay
	lsr	Txbyte			;Get next bit
	dec	bitcnt			;If not all bit sent
	brne	putchar0	;send next
						;else
;	pop		bitcnt
;	out		SREG,bitcnt
	ret					;return

;----------------------------------------------
; Some b values: 	(See also table in Appnote
;					 "AVR 305" documentation)
;
; 1 MHz crystal:
;   9600 bps - b=14
;  19200 bps - b=5
;  28800 bps - b=2
;
; 2 MHz crystal:
;  19200 bps - b=14
;  28800 bps - b=8
;  57600 bps - b=2

; 4 MHz crystal:
;  19200 bps - b=31
;  28800 bps - b=19
;  57600 bps - b=8
; 115200 bps - b=2

; 8MHz crystal:
;  9600 bps - b=135

UART_delay:
	ldi	Work2,b
UART_delay1:
	dec	Work2
	brne	UART_delay1
	ret
